ProtectedMemory.Protect Method

Updated: September 2010

Protects the specified data.

Namespace:  System.Security.Cryptography
Assembly:  System.Security (in System.Security.dll)

public static void Protect(
	byte[] userData,
	MemoryProtectionScope scope
)

Parameters

userData
Type: System.Byte[]

The byte array containing data in memory to protect. The array must be a multiple of 16 bytes.

scope
Type: System.Security.Cryptography.MemoryProtectionScope

One of the MemoryProtectionScope values.

ExceptionCondition
CryptographicException

userData must be 16 bytes in length or in multiples of 16 bytes.

PlatformNotSupportedException

The operating system does not support this method. This method can be used only with Microsoft Windows 2000 or later operating systems.

ArgumentNullException

userData is null.

This method can be used to protect data in memory. Note that the method does not make a copy of the data, but encrypts the byte array in place. The userData parameter must be 16 bytes in length or a multiple of 16 bytes.

Support for this method is available in Microsoft Windows XP and later operating systems.

The following code example shows how to use data protection.

using System;
using System.Security.Cryptography;

public class MemoryProtectionSample
{

	public static void Main()
	{
// Create the original data to be encrypted (The data length should be a multiple of 16).
		
byte [] secret = { 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4 };

// Encrypt the data in memory. The result is stored in the same same array as the original data.
		ProtectedMemory.Protect( secret, MemoryProtectionScope.SameLogon );
	
// Decrypt the data in memory and store in the original array.
		ProtectedMemory.Unprotect( secret, MemoryProtectionScope.SameLogon );
	}

}

Windows 7, Windows Vista, Windows XP SP2, Windows XP Media Center Edition, Windows XP Professional x64 Edition, Windows XP Starter Edition, Windows Server 2008 R2, Windows Server 2008, Windows Server 2003, Windows Server 2000 SP4, Windows Millennium Edition, Windows 98

The .NET Framework and .NET Compact Framework do not support all versions of every platform. For a list of the supported versions, see .NET Framework System Requirements.

.NET Framework

Supported in: 3.5, 3.0, 2.0

Date

History

Reason

September 2010

Corrected the summary.

Customer feedback.

Was this page helpful?
(1500 characters remaining)
Thank you for your feedback

Community Additions

ADD
Show:
© 2014 Microsoft